# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::KeyVault::V7_0_preview
  module Models
    #
    # Properties of the key pair backing a certificate.
    #
    class KeyProperties

      include MsRestAzure

      # @return [Boolean] Indicates if the private key can be exported.
      attr_accessor :exportable

      # @return [JsonWebKeyType] The type of key pair to be used for the
      # certificate. Possible values include: 'EC', 'EC-HSM', 'RSA', 'RSA-HSM',
      # 'oct'
      attr_accessor :key_type

      # @return [Integer] The key size in bits. For example: 2048, 3072, or
      # 4096 for RSA.
      attr_accessor :key_size

      # @return [Boolean] Indicates if the same key pair will be used on
      # certificate renewal.
      attr_accessor :reuse_key

      # @return [JsonWebKeyCurveName] Elliptic curve name. For valid values,
      # see JsonWebKeyCurveName. Possible values include: 'P-256', 'P-384',
      # 'P-521', 'P-256K'
      attr_accessor :curve


      #
      # Mapper for KeyProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'KeyProperties',
          type: {
            name: 'Composite',
            class_name: 'KeyProperties',
            model_properties: {
              exportable: {
                client_side_validation: true,
                required: false,
                serialized_name: 'exportable',
                type: {
                  name: 'Boolean'
                }
              },
              key_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kty',
                type: {
                  name: 'String'
                }
              },
              key_size: {
                client_side_validation: true,
                required: false,
                serialized_name: 'key_size',
                type: {
                  name: 'Number'
                }
              },
              reuse_key: {
                client_side_validation: true,
                required: false,
                serialized_name: 'reuse_key',
                type: {
                  name: 'Boolean'
                }
              },
              curve: {
                client_side_validation: true,
                required: false,
                serialized_name: 'crv',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
